﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.ApplicationModel;
using Windows.ApplicationModel.Activation;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

namespace UWPGridsBenchmark
{
    /// <summary>
    /// Provides application-specific behavior to supplement the default Application class.
    /// </summary>
    sealed partial class App : Application
    {
        /// <summary>
        /// Initializes the singleton application object.  This is the first line of authored code
        /// executed, and as such is the logical equivalent of main() or WinMain().
        /// </summary>
        public App()
        {
            C1.UWP.LicenseManager.Key =
                        "ACoBKgIqB4NVAFcAUABHAHIAaQBkAHMAQgBlAG4AYwBoAG0AYQByAGsAQkE+f6TG" +
                        "S5FeFWs5EPxMabJ46BVP2Xg8DR/uBezs9F38D3KbELoSWPyNU3rHBJ5S0L9XQ7qL" +
                        "zC9hl+4sx+OSsIdlIIUYtK6tANDa6hfEzkuGWMbReiv4gEa9JFt4dtAG/b+Ojm2m" +
                        "M8WKYTjcmQmdPLyGBsGGGQqaFNNBs2XIgvgd8VDj9kXHarvrw7DctoUxbn9MujK8" +
                        "Nn1YBgrbtle2Yh+1FSq7mZMEa3VEAyrQD5OggTfNVp/zd72CrhZF7WrxPGYn+hRa" +
                        "0lS/e+W3iELBFPAf/497yrEuJQIi0lxRkfMlBWb6KMHki/4A9uhgg8ZqxxfMZESJ" +
                        "VdVq1KirT+ok9QqzLR2Gxb7VOsxJpLtSZy78+hfe5eLPGi5/yeWmQx9cLM7Otkc2" +
                        "oO65gHrnOjAulEdKBkeuuXzzYzdUcZPciDROpZAUX6XfeG+6UYmaGKETXJWR1IT6" +
                        "5CEbg9/iGKotfiM5vRjjsdHzXOXGEUW8DyQctYK1OraWh3JgzZzvjxVUcP3R+sK1" +
                        "C/sRqEwPGMPyw7e0LM5rZL9l3nMWrUc+ApYPF9B8NRP6HnWilEdgqOFm2K4sVv14" +
                        "VwI+zzG8nXyj55XGREnUcetycrzanuD9rd/9g0EwZnzZcwA0Ah5+ENXtBgnFdbeZ" +
                        "ZIWXarwgNbml8cNR+OhC48vuwsFgCAn5GEIwggVVMIIEPaADAgECAhBBA3jSJjZZ" +
                        "ehbbJsa9EJSLMA0GCSqGSIb3DQEBBQUAMIG0MQswCQYDVQQGEwJVUzEXMBUGA1UE" +
                        "ChMOVmVyaVNpZ24sIEluYy4xHzAdBgNVBAsTFlZlcmlTaWduIFRydXN0IE5ldHdv" +
                        "cmsxOzA5BgNVBAsTMlRlcm1zIG9mIHVzZSBhdCBodHRwczovL3d3dy52ZXJpc2ln" +
                        "bi5jb20vcnBhIChjKTEwMS4wLAYDVQQDEyVWZXJpU2lnbiBDbGFzcyAzIENvZGUg" +
                        "U2lnbmluZyAyMDEwIENBMB4XDTE0MTIxMTAwMDAwMFoXDTE1MTIyMjIzNTk1OVow" +
                        "gYYxCzAJBgNVBAYTAkpQMQ8wDQYDVQQIEwZNaXlhZ2kxGDAWBgNVBAcTD1NlbmRh" +
                        "aSBJenVtaS1rdTEXMBUGA1UEChQOR3JhcGVDaXR5IGluYy4xGjAYBgNVBAsUEVRv" +
                        "b2xzIERldmVsb3BtZW50MRcwFQYDVQQDFA5HcmFwZUNpdHkgaW5jLjCCASIwDQYJ" +
                        "KoZIhvcNAQEBBQADggEPADCCAQoCggEBAMEC9splW7KVpAqRB6VVB7XJm8+a60x7" +
                        "8HZWNmvAjs/ermp7pbh8M9HYuEVTRj8H4baXxFYq4i75e5kNr7s+nGbJ5UfM6Cld" +
                        "qbeRsQ4zvRb6npfrtcOBwfYOx0woeYQfI6VzLVzhPbGjUDK6qdHZLf/EcvSIKvRb" +
                        "u3ILOE3kuux07gQkb++rrSBUyJKXU8nW8c+K+9sfWqHYPb8FF2IazWxhmfIdIoDN" +
                        "Kyjr3r/wIn3jQejpqfamiHNsU/O26KS0EcvCS5CFOKDT6vvdnAkek3kyLWef+ca/" +
                        "cbFo74vawYGtmw2wzw/hcwlANIQaCAxz+5JHQZ3SEg8LLSZ+C8E4T+8CAwEAAaOC" +
                        "AY0wggGJMAkGA1UdEwQCMAAwDgYDVR0PAQH/BAQDAgeAMCsGA1UdHwQkMCIwIKAe" +
                        "oByGGmh0dHA6Ly9zZi5zeW1jYi5jb20vc2YuY3JsMGYGA1UdIARfMF0wWwYLYIZI" +
                        "AYb4RQEHFwMwTDAjBggrBgEFBQcCARYXaHR0cHM6Ly9kLnN5bWNiLmNvbS9jcHMw" +
                        "JQYIKwYBBQUHAgIwGQwXaHR0cHM6Ly9kLnN5bWNiLmNvbS9ycGEwEwYDVR0lBAww" +
                        "CgYIKwYBBQUHAwMwVwYIKwYBBQUHAQEESzBJMB8GCCsGAQUFBzABhhNodHRwOi8v" +
                        "c2Yuc3ltY2QuY29tMCYGCCsGAQUFBzAChhpodHRwOi8vc2Yuc3ltY2IuY29tL3Nm" +
                        "LmNydDAfBgNVHSMEGDAWgBTPmanqeyb0S8mOj9fwBSbv49KnnTAdBgNVHQ4EFgQU" +
                        "AFrwraXUeDX1hBKoLAUO+FYbjo4wEQYJYIZIAYb4QgEBBAQDAgQQMBYGCisGAQQB" +
                        "gjcCARsECDAGAQEAAQH/MA0GCSqGSIb3DQEBBQUAA4IBAQCIwphaN45b5ViKsRfC" +
                        "A6hbVeqMhNCJmL64mqxdYvw3gsF4oOCDoiM6kWhy1NoUd2Lpcr9PjfGJ55ZX4sZl" +
                        "qoxeflTpHgnX8MPJuKpDBsk7WkhiEu65fBwb+g9wQHMMfgY0gjHIAQ2ZEf2PJ6TT" +
                        "SFcvj24wh73dsyqcmj290fpwDtHaF2jE5pq/tQBOJ8vDkN46wt4qMhG6nIpOgc9K" +
                        "ngyLLdEO7V34KM1Nb+sN9JkqTWXNoNqlOf7QjYHwlw7Ku7W3kIGK+f1kP1xqTBpX" +
                        "wsBE5sLlnujP+JAqV8aKlBJDKRI3IhlrG9CJUmqFNhmZ2f5QE5jAvPQeXevLnMYi" +
                        "qJrgMIICxDCCAaygAwIBAgIEDu7u7jANBgkqhkiG9w0BAQUFADAkMSIwIAYDVQQD" +
                        "DBlHQy1VV1AgSW50ZXJuYWwgRGV2ZWxvcGVyMB4XDTE2MTIyOTE3NDcwM1oXDTIx" +
                        "MTIyOTE3NDcwM1owJDEiMCAGA1UEAwwZR0MtVVdQIEludGVybmFsIERldmVsb3Bl" +
                        "cjCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN47qF6wDTzQJc1gkU+0" +
                        "DC+hZaU/wmqDBx/QFqqp5OORI4d88Ye8bqAgHQLt67UEV/SmfhIhc4dTVz8aEY/X" +
                        "ulxoNI7IoGMR+Kp7r6fLMFfo5eRYqJW5IdLqKZEq+WIPiSwdp/qV9kFj/dOOTWna" +
                        "SbaKEv/ALVVFkYZdEn4s7KyptwrMWixAiYZ7eCtMSR078bRbY7S8+s/ZcNGis90J" +
                        "j1q+OJtxdZ7ULxPN/htyR6cdxTwFWrVM9lweWv8IhSA+QnLE+6OxhfuOLbEZeeJQ" +
                        "DXlmMoYd5Q3MloA02dBvLXZS4S/d9M9I4LPIDnXwy12NnqLIyIyG5pOpgZkVhAWA" +
                        "9U0CAwEAATANBgkqhkiG9w0BAQUFAAOCAQEAL7oOt9TuVyYeaIBTV6xZrtveQbh4" +
                        "1EqUj5dh4Qy2c+l+7WTILRR/gmw0f7LC72arHOoH5p9nDXI1Yhw1oihoyJUE4T+J" +
                        "8dtLX3UEWpH+Dq7z+8BVqGOtB9GkUln/c599gYqY0/8H6HLasGG2EPwtEPwotbCO" +
                        "hsC0MYeY3HkUs4a2TU9g1lyv4vrVcNz0xeVFKle1A2QWjiLwuK7zEy2e+Gsuegbw" +
                        "5e0I/rk3xmQyR+X01ODxFNwwK4ywQ0MpaiAboTdRESvaxAFW4awYYI1ddzE3x2sN" +
                        "KmR/R9ncimLT82BXvykkL0rafTct1llCrW0nww2LQn1vdn8+uASx6asg3g==";
            this.InitializeComponent();
            this.Suspending += OnSuspending;
        }

        /// <summary>
        /// Invoked when the application is launched normally by the end user.  Other entry points
        /// will be used such as when the application is launched to open a specific file.
        /// </summary>
        /// <param name="e">Details about the launch request and process.</param>
        protected override void OnLaunched(LaunchActivatedEventArgs e)
        {
#if DEBUG
            if (System.Diagnostics.Debugger.IsAttached)
            {
                this.DebugSettings.EnableFrameRateCounter = true;
            }
#endif
            Frame rootFrame = Window.Current.Content as Frame;

            // Do not repeat app initialization when the Window already has content,
            // just ensure that the window is active
            if (rootFrame == null)
            {
                // Create a Frame to act as the navigation context and navigate to the first page
                rootFrame = new Frame();

                rootFrame.NavigationFailed += OnNavigationFailed;

                if (e.PreviousExecutionState == ApplicationExecutionState.Terminated)
                {
                    //TODO: Load state from previously suspended application
                }

                // Place the frame in the current Window
                Window.Current.Content = rootFrame;
            }

            if (e.PrelaunchActivated == false)
            {
                if (rootFrame.Content == null)
                {
                    // When the navigation stack isn't restored navigate to the first page,
                    // configuring the new page by passing required information as a navigation
                    // parameter
                    rootFrame.Navigate(typeof(MainPage), e.Arguments);
                }
                // Ensure the current window is active
                Window.Current.Activate();
            }
        }

        /// <summary>
        /// Invoked when Navigation to a certain page fails
        /// </summary>
        /// <param name="sender">The Frame which failed navigation</param>
        /// <param name="e">Details about the navigation failure</param>
        void OnNavigationFailed(object sender, NavigationFailedEventArgs e)
        {
            throw new Exception("Failed to load Page " + e.SourcePageType.FullName);
        }

        /// <summary>
        /// Invoked when application execution is being suspended.  Application state is saved
        /// without knowing whether the application will be terminated or resumed with the contents
        /// of memory still intact.
        /// </summary>
        /// <param name="sender">The source of the suspend request.</param>
        /// <param name="e">Details about the suspend request.</param>
        private void OnSuspending(object sender, SuspendingEventArgs e)
        {
            var deferral = e.SuspendingOperation.GetDeferral();
            //TODO: Save application state and stop any background activity
            deferral.Complete();
        }
    }
}
